@echo off
@setlocal enableextensions enabledelayedexpansion
REM Todo:
REM Make log and skip optional

set BATDIR=%~dp0

call :INI "%BATDIR%\config.ini" General bDebug _debug
call :VarToBoolean _debug
call :INI "%BATDIR%\config.ini" General sVideocleaner _cleaner
call :INI "%BATDIR%\config.ini" Logging bLogging _logging
call :VarToBoolean _logging
call :INI "%BATDIR%\config.ini" Logging bUseMD5 _usemd5
call :VarToBoolean _usemd5
call :INI "%BATDIR%\config.ini" Tags bMoveTags _movetags
call :VarToBoolean _movetags
call :INI "%BATDIR%\config.ini" Tags sMoveTagsPath _movetagspath

if NOT exist "%_cleaner%" (
	echo Executable not found^^!
	echo.
	echo Please confirm the the videocleaner
	echo path in config.ini and try again.
	echo.
	echo Press any key to close...
	if %_debug%==1 (
		echo _cleaner=%_cleaner%
		echo _movetags=%_movetags%
		echo _movetagspath=%_movetagspath%
		echo _tagdest=%_tagdest%
		echo _usemd5=%_usemd5%
		echo.
	)
	pause>nul
	goto :EOF
)

if %_usemd5%==1 (
	if %_debug%==1 echo Begin test FCIV.
	set _hasfciv=0
	for /f "eol=/ tokens=2" %%E in ('fciv') do (
		 if %%E==fciv.exe set _hasfciv=1
	)
	if !_hasfciv!==0 (
		echo fciv not found^^!
		echo.
		echo Please ensure fciv in installed
		echo and is on your PATH variable, or
		echo disable bUseMD5 and try again.
		echo.
		echo Press and key to close...
		pause>nul
		goto :EOF
	)
)
rem echo _hasfciv=%_hasfciv%

if %_movetagspath%==custom (
	call :INI "%BATDIR%\config.ini" Tags sMoveTagsCustom _tagdest
	if NOT defined _tagdest (
		echo Error: MoveTagsPath=custom but MoveTagsCustom is not defined^^!
		echo Defaulting to 'file'.
		set _tagdest=%cd%\tags
	) else (
		if NOT exist !_tagdest!\nul (
			echo Error: MoveTagsCustom path invalid or doesn't exist^^!
			echo Defaulting to 'file'.
			set _tagdest=%cd%\tags
		)
	)
) else (
	if %_movetagspath%==file (
		set _tagdest=%cd%\tags
	) else (
		if %_movetagspath%==script (
			set _tagdest=%BATDIR%\tags
			if NOT exist !_tagdest!\nul (
				md !_tagdest!
			)
		) else (
			echo Error: MoveTagsPath not recognized^^!
			echo Defaulting to 'file'.
			set _tagdest=%cd%\tags
		)
	)
)



if "%~1"=="" (
	goto NoFiles
)
	
for %%H in (%*) do (
	if %_debug%==1 echo Begin checking parameters.
	REM echo %%H
	REM echo "%%~xH"
	if [%%~xH]==[] (
		if %_debug%==1 echo Extension blank^^!
		if exist %%H\nul (
			if %_debug%==1 echo Folder exists
			call :ProcessFolder %%H
		) else (
			if %_debug%==1 echo Folder is nope
			call :ProcessFiles %%H
			echo.
		)
	) else (
		if %_debug%==1 echo Has extension, process file
		call :ProcessFiles %%H
		echo.
	)
)
goto EndOfFile

:VarToBoolean
set variable=%~1
REM echo V2B:%variable%=!%variable%!
if !%variable%!==0 (
	exit /B
)
if !%variable%!==1 (
	exit /B
)
if /I !%variable%!==False (
	set !variable!=0
	exit /B
)
if /I !%variable%!==True (
	set !variable!=1
	exit /B
)
REM echo V2B: Set fails to False
set !variable!=0
exit /B


REM USE: call :INI inifile iniarea inikey variable
:INI
rem INI Parsing script by paxdiablo
rem https://stackoverflow.com/a/2866328
set file=%~1
set area=[%~2]
set key=%~3
set variable=%~4
set currarea=
for /f "usebackq delims=" %%A in ("!file!") do (
    set ln=%%A
    if "x!ln:~0,1!"=="x[" (
        set currarea=!ln!
    ) else (
        for /f "tokens=1,2 delims==" %%B in ("!ln!") do (
            set currkey=%%B
            set currval=%%C
            if "x!area!"=="x!currarea!" if "x!key!"=="x!currkey!" (
                set !variable!=!currval!
            )
        )
    )
)
exit /B

:NoFiles
echo To use this script, drag any number
echo of videos or folders of videos onto the script.
echo Each one will be cleaned in turn,
echo after which the script will pause
echo to allow you to read the results
echo.
if %_debug%==1 (
	echo _cleaner=%_cleaner%
	echo _movetags=%_movetags%
	echo _movetagspath=%_movetagspath%
	echo _tagdest=%_tagdest%
	echo _usemd5=%_usemd5%
	echo.
)
echo Press any key to close...
pause>nul
goto :EOF

:ProcessFolder
for %%I in (%1\*) do (
	REM echo %%I
	if [%%~xI]==[] (
		REM echo Extension blank!
		if exist %%I\nul (
			REM echo Folder exists
			call :ProcessFolder "%%I"
		) else (
			REM echo Folder is nope
		call :ProcessFiles "%%I"
			echo.
		)
	) else (
		call :ProcessFiles "%%I"
		echo.
	)
)
exit /B

:ProcessFiles
if %_debug%==1 echo Begin processing %1
REM echo %BATDIR%cleanedfiles.log
if %_logging%==1 (
	if %_debug%==1 echo _usemd5=%_usemd5%
	if %_usemd5%==1 (
		if %_debug%==1 echo Begin test MD5.
		for /F "eol=/" %%J in ('fciv %1') DO set _initialMD5=%%J
		for /F %%K in (%BATDIR%cleanedMD5s.log) DO (
			if /I %%K==!_initialMD5! (
				echo File "%~nx1" previously cleaned.
				exit /B
			)
		)
	) else (
		if %_debug%==1 echo Begin test file path.
		for /F "delims=" %%G in (%BATDIR%cleanedfiles.log) DO (
			REM echo "%1"
			REM echo vs
			REM echo "%%G"
			if /I %%G==%1 (
				echo File "%~nx1" previously cleaned.
				exit /B
			) else (
				REM echo No match.
			)
			REM echo.
		)
	)
)
echo %~nx1
"%_cleaner%" -f %1
if EXIST "%~dpnx1.tag" (
	REM echo TAG EXISTS
	if _movetags==1 (
		if %_movetagspath%==file (
			if NOT exist !_tagdest!\nul (
				REM echo FOLDER NO BE
				md !_tagdest!
			)
		)
		move "%~dpnx1.tag" "!_tagdest!\%~nx1.tag"
	)
)
if %_logging%==1 (
	if %_usemd5%==1 (
		for /F "eol=/" %%L in ('fciv %1') do set _finalMD5=%%L
		echo !_finalMD5!>>%BATDIR%\cleanedMD5s.log
	) else (
		echo %1>>%BATDIR%\cleanedfiles.log
	)
)
exit /B

:EndOfFile
echo Press any key to close...
pause>nul
goto :EOF
